unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, StdCtrls, TeEngine, TeeTools, Series, OHLChart, CandleCh,
  ExtCtrls, TeeProcs, Chart, StatChar, TeeEdit;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TCandleSeries;
    ChartTool1: TAnnotationTool;
    ChartTool2: TAnnotationTool;
    Button1: TButton;
    Series2: TFastLineSeries;
    TeeFunction1: TStochasticFunction;
    ChartEditor1: TChartEditor;
    Label1: TLabel;
    Label2: TLabel;
    Series3: TVolumeSeries;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
  private
    { Private declarations }
    function InterpolateLineSeries(Series: TChartSeries;XValue: Double): Double; overload;
    function InterpolateLineSeries(Series: TChartSeries; FirstIndex,
                                  LastIndex: Integer; XValue: Double): Double; overload;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Click;
end;

function TForm1.InterpolateLineSeries(Series: TChartSeries;
  XValue: Double): Double;
begin
  result:=InterpolateLineSeries(Series,Series.FirstDisplayedIndex,Series.LastValueIndex,XValue);
end;

function TForm1.InterpolateLineSeries(Series: TChartSeries; FirstIndex,
  LastIndex: Integer; XValue: Double): Double;
var
  Index: Integer;
  dx,dy: Double;
begin
  for Index:=FirstIndex to LastIndex do
    if Series.XValues.Value[Index]>XValue then break;

  //safeguard
  if (Index<1) then Index:=1
  else if (Index>=Series.Count) then Index:=Series.Count-1;

  // y=(y2-y1)/(x2-x1)*(x-x1)+y1
  dx:=Series.XValues.Value[Index] - Series.XValues.Value[Index-1];
  dy:=Series.YValues.Value[Index] - Series.YValues.Value[Index-1];

  if (dx<>0) then
    result:=dy*(XValue - Series.XValues.Value[Index-1])/dx + Series.YValues.Value[Index-1]
  else result:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Chart1.View3D:=False;

  Series1.FillSampleValues(500);
  Series2.FillSampleValues(500);
  Series3.FillSampleValues(500);

  Chart1.Draw;
end;

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
ChartEditor1.Execute;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var {Index , VOl, Stoc: Integer;

  wX, wYl ,wYr: double;

  S : string;
  tmpX,tmpY: Double;
  tmpL,tmpL2,ClickedValue : Integer;
}
  xval: Double;

begin
{
  with chart1 do
  if not PtInRect(ChartRect, Point(X,Y)) then
    Hint:=Parent.Hint
  else begin
    wX:=BottomAxis.CalcPosPoint(X);
    wYl:=LeftAxis.CalcPosPoint(Y);
  // wYr := ri
    wYr:=RightAxis.CalcPosPoint(y);
    if wX<30000 then
      S:='X:'+Format('%8.2f',[wX])
    else
      S:='X:'+FormatDateTime('yyyy:mm:dd',wX);

    //caption:=S+' YL:'+Format('%f',[wYr]);
   // searchgrid(FormatDateTime('yyyy-mm-dd',wX));
    caption:=S+' wYl:'+Format('%8.2f',[wYl])+' wYr:'+Format('%8.2f',[wYr]);
  end;


  Stoc :=Series1.Clicked(x,y);

  Index:=Series2.Clicked(X, Y);
  VOl := Series3.Clicked(x,y);



  label3.Caption :=  DateToStr(Series1.DateValues[Stoc]);
  label1.Caption:='Stockhastic : '+FloatToStr(Series2.YValues[Index]);
  label2.Caption:='Volume : '+FloatToStr(Series3.xValues[VOl]);
}

  xval := Chart1.Axes.Bottom.CalcPosPoint(X);

  label3.Caption :=  DateToStr(FloatToDateTime(xval));
  label1.Caption:='Stockhastic : '+FloatToStrF(InterpolateLineSeries(Series2,xval), ffNumber, 8, 2);
  label2.Caption:='Volume : '+FloatToStrF(InterpolateLineSeries(Series3,xval), ffNumber, 8, 2);
end;




end.
